"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* global describe, it, before, afterEach */
const assert = require("assert");
const http = require("http");
const path = require("path");
const express = require("express");
const node_fetch_1 = require("node-fetch");
const src_1 = require("../src");
const PORT = 3031;
const GET = (url, obj) => __awaiter(void 0, void 0, void 0, function* () { return assert.deepStrictEqual(yield node_fetch_1.default(`http://localhost:${PORT}${url}`, { method: 'GET' }).then(res => res.json()), obj); });
// const POST = async (url: string, body: any, obj: any) => assert.deepStrictEqual(await fetch(`http://localhost:3000${url}`, { method: 'POST', body }).then(res => res.json()), obj);
// const PUT = async (url: string, body: any, obj: any) => assert.deepStrictEqual(await fetch(`http://localhost:3000${url}`, { method: 'PUT', body }).then(res => res.json()), obj);
// const DELETE = async (url: string, obj: any) => assert.deepStrictEqual(await fetch(`http://localhost:3000${url}`, { method: 'DELETE' }).then(res => res.json()), obj);
// const ERROR_RESPONSE = { code: 400, status: 'error', message: 'Method Not Implemented' };
const app = express();
const api = src_1.default(express, {
    root: path.join(__dirname, 'fixtures', 'sideways'),
});
app.use('/api', api);
// Start Server
http.createServer(app).listen(PORT, function () {
    console.log(('Express server listening on port ' + app.get('port')));
});
describe('API Discovery', function () {
    describe('it should', function () {
        it('works at root', function () {
            return __awaiter(this, void 0, void 0, function* () {
                yield GET('/api', { status: 'success', data: 'ok' });
            });
        });
        it('works with route', function () {
            return __awaiter(this, void 0, void 0, function* () {
                yield GET('/api/user', { firstName: 'Ash', lastName: 'Ketchum', pkmnCount: 151, age: 12 });
            });
        });
        it('works with route sideways call', function () {
            return __awaiter(this, void 0, void 0, function* () {
                yield GET('/api/miniprofile', { name: 'Ash Ketchum' });
            });
        });
    });
});
//# sourceMappingURL=sideways.test.js.map